---
title: IDBDatabase.transaction()
slug: Web/API/IDBDatabase/transaction
tags:
  - API
  - Database
  - IDBDatabase
  - IndexedDB
  - Method
  - Reference
  - Storage
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>transaction</code></strong> method of the {{domxref("IDBDatabase")}} interface imm<span style="line-height: 1.5;">ediately returns a transaction object ({{domxref("IDBTransaction")}}) containing the {{domxref("IDBTransaction.objectStore")}} method, which you can use to access your object store.</span></p>

<p>{{AvailableInWorkers}}</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>IDBDatabase</em>.transaction(<em>storeNames</em>);
<em>IDBDatabase</em>.transaction(<em>storeNames</em>, <em>mode</em>);
<em>IDBDatabase</em>.transaction(<em>storeNames</em>, <em>mode, options</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>storeNames</code></dt>
 <dd>The names of object stores that are in the scope of the new transaction, declared as an array of strings. Specify only the object stores that you need to access.<br>
 If you need to access only one object store, you can specify its name as a string. Therefore the following lines are equivalent:</dd>
 <dd>
 <pre class="brush: js notranslate">var transaction = db.transaction(['my-store-name']);
var transaction = db.transaction('my-store-name');</pre>
 </dd>
 <dd>If you need to access all object stores in the database, you can use the property {{domxref("IDBDatabase.objectStoreNames")}}:
 <pre class="brush: js notranslate">var transaction = db.transaction(db.objectStoreNames);</pre>
 </dd>
 <dd>Passing an empty array will throw an exception.</dd>
 <dt><code>mode</code> {{optional_inline}}</dt>
 <dd>The types of access that can be performed in the transaction. Transactions are opened in one of three modes: <code>readonly</code>, <code>readwrite</code> and <code>readwriteflush</code> (non-standard, Firefox-only.) <code>versionchange</code> mode can't be specified here. If you don't provide the parameter, the default access mode is <code>readonly</code>. To avoid slowing things down, don't open a <code>readwrite</code> transaction unless you actually need to write into the database.</dd>
 <dd>If you need to open the object store in <code>readwrite</code> mode to change data, you would use the following:
 <pre class="brush:js; notranslate">var transaction = db.transaction('my-store-name', "readwrite");</pre>

 <p>As of Firefox 40, IndexedDB transactions have relaxed durability guarantees to increase performance (see {{Bug("1112702")}}), which is the same behaviour as other IndexedDB-supporting browsers. Previously in a <code>readwrite</code> transaction {{domxref("IDBTransaction.oncomplete")}} was fired only when all data was guaranteed to have been flushed to disk. In Firefox 40+ the <code>complete</code> event is fired after the OS has been told to write the data but potentially before that data has actually been flushed to disk. The <code>complete</code> event may thus be delivered quicker than before, however, there exists a small chance that the entire transaction will be lost if the OS crashes or there is a loss of system power before the data is flushed to disk. Since such catastrophic events are rare most consumers should not need to concern themselves further.</p>

 <div class="note">
 <p><strong>Note</strong>: In Firefox, if you wish to ensure durability for some reason (e.g. you're storing critical data that cannot be recomputed later) you can force a transaction to flush to disk before delivering the <code>complete</code> event by creating a transaction using the experimental (non-standard) <code>readwriteflush</code> mode (see {{domxref("IDBDatabase.transaction")}}.) This is currently experimental, and can only be used if the <code>dom.indexedDB.experimental</code> pref is set to <code>true</code> in <code>about:config</code>.</p>
 </div>
 </dd>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>Dictionary of other options. Available options are:
 <ul>
  <li><code>durability</code>: <code>"default"</code>, <code>"strict"</code>, or <code>"relaxed"</code>. The default is <code>"default"</code>. Using <code>"relaxed"</code> provides better performance, but with fewer guarantees. Web applications are encouraged to use <code>"relaxed"</code> for ephemeral data such as caches or quickly changing records, and <code>"strict"</code> in cases where reducing the risk of data loss outweighs the impact to performance and power.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("IDBTransaction")}} object.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of one of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code><a href="/en-US/docs/IndexedDB/IDBDatabaseException#NOT_ALLOWED_ERR">I</a>nvalidStateError</code></td>
   <td>
    <p>The <code>close()</code> method has previously been called on this {{domxref("IDBDatabase")}} instance.</p>
   </td>
  </tr>
  <tr>
   <td><code>NotFoundError</code></td>
   <td>An object store specified in the <code>storeNames</code> parameter has been deleted or removed.</td>
  </tr>
  <tr>
   <td><code>TypeError</code></td>
   <td>The value for the <code>mode</code> parameter is invalid.</td>
  </tr>
  <tr>
   <td><code>InvalidAccessError</code></td>
   <td>The function was called with an empty list of store names.<br>
     </td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>In this example we open a database connection, then use transaction() to open a transaction on the database. For a complete example, see our <a href="https://github.com/mdn/to-do-notifications/" style="line-height: 1.5;">To-do Notifications</a><span style="line-height: 1.5;"> app (</span><a href="https://mdn.github.io/to-do-notifications/" style="line-height: 1.5;">view example live</a><span style="line-height: 1.5;">.)</span></p>

<pre class="brush: js notranslate">var db;

// Let us open our database
var DBOpenRequest = window.indexedDB.open("toDoList", 4);

DBOpenRequest.onsuccess = function(event) {
  note.innerHTML += '&lt;li&gt;Database initialised.&lt;/li&gt;';

  // store the result of opening the database in the db variable.
  // This is used a lot below
  db = DBOpenRequest.result;

  // Run the displayData() function to populate the task list with
  // all the to-do list data already in the IDB
  displayData();

};

// open a read/write db transaction, ready for adding the data
var transaction = db.transaction(["toDoList"], "readwrite");

// report on the success of opening the transaction
transaction.oncomplete = function(event) {
  note.innerHTML += '&lt;li&gt;Transaction completed: database modification finished.&lt;/li&gt;';
};

transaction.onerror = function(event) {
  note.innerHTML += '&lt;li&gt;Transaction not opened due to error. Duplicate items not allowed.&lt;/li&gt;';
};

// you would then go on to do something to this database
// via an object store
var objectStore = transaction.objectStore("toDoList");
// etc.</pre>

<h2 id="Specification"><span style="font-size: 2.14285714285714rem;">Specification</span></h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbdatabase-transaction', 'transaction()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbdatabase-transaction", "transaction()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBDatabase.transaction")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
